		/************************************************* 
                 *     Projet reconnaissance de formes		 * 
		 *  	     Module ART1			 * 
		 *  						 * 
		 *  Valvassori Mose -  Matricule: 149397	 * 
		 *  						 * 
		 *  		$Id:$				 * 
                 *************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "art.h"

typedef unsigned char Binaire;

#define NOMBRE_NEURONE_ENTREE  TAILLE_MAX*TAILLE_MAX	/*+  +*/

float Rho= 0.70;

double ltm[NOMRE_PATTERN_RECONNAISABLE]; /*+ Mmoire  long terme +*/
Binaire stm[NOMBRE_NEURONE_ENTREE];	/*+ Mmoire  court terme +*/

double bup[NOMBRE_NEURONE_ENTREE][NOMRE_PATTERN_RECONNAISABLE]; /*+ Connections bottom-up +*/
Binaire topd[NOMRE_PATTERN_RECONNAISABLE][NOMBRE_NEURONE_ENTREE]; /*+ Connections top-down +*/
Binaire mu[NOMRE_PATTERN_RECONNAISABLE]; /*+ active/inhibe un attracteur +*/


static int prod_scal(int k);


double erreur;				/*+ Erreur de reconnaissance - Debug only +*/
int attracteur_max;			/*+ Dernier attracteur en activite +*/


extern CELL * patt[];

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Initialise les poids du reseau

  int initialisation renvoie toujours 1
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int initialisation(void){
  int i,j;
  double init = 1.0 / (1.0 + NOMBRE_NEURONE_ENTREE);


  for (j=0; j<NOMRE_PATTERN_RECONNAISABLE; j++)
    for (i=0; i<NOMBRE_NEURONE_ENTREE; i++){
      topd[j][i]=1;
      bup[i][j] = init;
    }

  attracteur_max=0;
  return (1);
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Applique le pattern sur les entres

  int applique_le_pattern

  CELL * in le pattern  appliquer
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int applique_le_pattern(CELL * in){
  int i,j,n=0;

  for (j=0; j<TAILLE_MAX; j++){
    for (i=0; i<TAILLE_MAX; i++){
      stm[n++]= acces(in,i,j) != 0;
    }}

  /* Dinhibe les attracteurs */
  for (j=0; j<NOMRE_PATTERN_RECONNAISABLE; j++)
    mu[j]=1;


  return(1);
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Calcule les valeurs d'activation des attracteurs

  int calcul_activation renvoie l'index de l'attracteur max
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int calcul_activation(void){
  int i,j;
  int amax=-1,flag=TRUE;
  double max=0;

  for (j=0; j<NOMRE_PATTERN_RECONNAISABLE; j++){
    if (mu[j]==1) {
      ltm[j]=0.0;
      for (i=0; i<NOMBRE_NEURONE_ENTREE; i++)
	ltm[j] += bup[i][j] * stm[i]; 
      
      if (flag==TRUE){				/* Calcule le max dans la foule */
	max=ltm[j];
	amax=j;
	flag=FALSE; }
      else if (ltm[j]>max){
	amax = j;
	max=ltm[j];
      }
       /*  printf("%d %f \n",j,ltm[j]); */
    }}
  /*  printf("max %d ",amax); fflush(0); */
  return (amax);
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  prdicat qui dit si l'elue est suffisamment proche de l'entre

  int vigilance vrai/faux ou -1 si erreur

  int j l'index de l'elue.
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int vigilance(int j){
  int i;
  int xx=0;
  int wx=0;

  if (j<0)
    return (-1);

  for (i=0; i<NOMBRE_NEURONE_ENTREE; i++){
    xx += stm[i];
    wx += topd[j][i] * stm[i];
  }

  erreur = ((double)wx/xx);
    /*  printf(". %d %d %f\n",xx,wx,erreur); */
  if (((double)wx/xx) > Rho)
    return (TRUE);
  else
    return (FALSE);
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Inhibe un attracteur

  int inhibe

  int e l'attracteur  inhiber
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int inhibe(int e){
  if (e<0)
    return (0);

  mu[e]=0;
/*  printf("inib %d\n",e); */
  return (1);
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  

  int modifier_les_poids

  int k
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int modifier_les_poids(int k){
   int i;
  double demominateur;

  if (k<0)
    return (0);

  demominateur= 0.5 + prod_scal(k);

  for (i=0; i<NOMBRE_NEURONE_ENTREE; i++){
    topd[k][i] = topd[k][i] * stm[i];
    bup[i][k]= topd[k][i] / demominateur ;
  }

  if (k>attracteur_max)			/* C'est ici que l'on modifie attracteur max */
    attracteur_max=k;

  return (1);
}


static int prod_scal(int k){
  int i;
  int ret=0;
 
  for (i=0; i<NOMBRE_NEURONE_ENTREE; i++)
    ret += topd[k][i] * stm[i];   
  return (ret);
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  

  int affiche_attracteur

  int a
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int affiche_attracteur(int a){
  int i,j,n=0;

  for (j=0; j<TAILLE_MAX; j++){
    for (i=0; i<TAILLE_MAX; i++){
      printf("%c",topd[a][n++]?'#':' ');
    }
    printf("\n");
  }

  return(1);

}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void apprend(){
  int i,max=0;
  int elue;

  initialisation();
  do {
    max=attracteur_max;
    for (i=0; i<10; i++){
      applique_le_pattern(patt[i]);
    
      while(1) {
	elue=calcul_activation();

	if (vigilance(elue))
	  break;
	else
	  inhibe(elue);
      };
      printf("> %d %f %d\n",i,erreur,elue);
      modifier_les_poids(elue);
    }
  }while(max<attracteur_max);

}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void affiche_attracteurs(void){
  int i;
  for (i=0; i<attracteur_max; i++){
    affiche_attracteur(i);
    printf("\n");
  }
}

