                /************************************************* 
                 *     Projet reconnaissance de formes		 * 
		 *  	     Module ART1			 * 
		 *  	  Fichier principal			 * 
		 *  Valvassori Mose -  Matricule: 149397	 * 
		 *   						 * 
		 *  		$Id:$				 * 
                 *************************************************/

#include <stdlib.h>
#include <time.h>
#include "nistdb.h"
#include "art.h"


#define NB_echantillon 5
#define NOMBRE_ELEMENT 10
extern double erreur;
extern int attracteur_max;

#define TAILLE_CONFUSION_Y 10		/*+ Taille de la matrice de confusion +*/
#define TAILLE_CONFUSION_X TAILLE_CONFUSION_Y+2


static int *index=NULL;			/*+ Liste des indexs des chiffre  apprendre +*/
int Verbose=11;				/*+ 0 pas de sortie 11 sortie maxi +*/
static clock_t t1;


int correspondance[NOMRE_PATTERN_RECONNAISABLE]; /*+ Affecte un chiffre  chaque attracteur +*/


FILE *a,*b,*c;

void affiche_apprentissage_echantillon(int i);
int reconnait(FILE *f,unsigned char in[TAILLE_MAX][TAILLE_MAX]);
extern void affiche_attracteur(int);

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Construit l'index des lettres  apprendre

  FILE *f

  int echantillon le nombre d'chantillon
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
static void construit_index(FILE *f,int echantillon){
  int i,j,p;

  /*  affiche_construit_index(); */

  index=(int *) malloc(echantillon*NOMBRE_ELEMENT*sizeof(int));
  for (i=0; i<NOMBRE_ELEMENT; i++){
    p=cherche_chiffre(f,i);
    for (j=0; j<echantillon; j++){
      index[i+j*NOMBRE_ELEMENT]=p;
      p++;
    }
  }
}




/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Constuit la matrice de confusion

  FILE *f la base de donne

  float confusion[][]  la matrice de confusion
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void construit_matrice_confusion(FILE *f,float confusion[TAILLE_CONFUSION_X][TAILLE_CONFUSION_Y]){
  int i,r,n;
  int compteur_nombre_chiffre[NOMBRE_ELEMENT];
  unsigned char chiffre[TAILLE_MAX][TAILLE_MAX];

  for (i=0; i<NOMBRE_ELEMENT; i++)
    compteur_nombre_chiffre[i]=0;

  for (i=0; i<TAILLE_NIST; i++){
    n=LitRAW(f,chiffre,i);
    /*     AfficheRAW(chiffre); */
    affiche_apprentissage_echantillon(i);
    r=reconnait(f,chiffre);
    confusion[r+2][n]++;
    compteur_nombre_chiffre[n]++;
  }
  
  confusion[0][r]=0;
  for (r=0; r<TAILLE_CONFUSION_Y; r++)
    for (i=0; i<TAILLE_CONFUSION_X; i++){
      confusion[i][r] /= compteur_nombre_chiffre[r];
      if ((i>1) && (i != r+2))
	confusion[0][r] += confusion[i][r];
    }
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Affiche la matrice de confusion

  FILE *f la base de caracctre
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void matrice_confusion(FILE *f){
  int i,j;
  float confusion[TAILLE_CONFUSION_X][TAILLE_CONFUSION_Y];

  for (j=0; j<TAILLE_CONFUSION_Y; j++)
    for (i=0; i<TAILLE_CONFUSION_X; i++)
      confusion[i][j]=0.0;

  construit_matrice_confusion(f,confusion);
  printf("\nI |\t Err \t Inc\t 0\t 1\t 2\t 3\t 4\t 5\t 6\t 7\t 8\t 9\n");
  for (j=0; j<TAILLE_CONFUSION_Y; j++){
    printf("%d |\t",j);
    for (i=0; i<TAILLE_CONFUSION_X; i++){
      printf("%2.2f\t",confusion[i][j]*100);
    }
    printf("\n");
  }
}



int reconnait(FILE *f,unsigned char in[TAILLE_MAX][TAILLE_MAX]){
  applique_le_pattern(in);
  return(calcul_activation());
}


int main (void)
{
  FILE *f;
  unsigned char chiffre[TAILLE_MAX][TAILLE_MAX];
  int valeur;
  int elue;
  int i,max=0;

  f=ouvrir_base("/home/djedi/fac/rdf/nistdb");

  /*  a=fopen("/tmp/aa","w");
   *  c=fopen("/tmp/bb","w"); */

  construit_index(f,NB_echantillon);
  initialisation();
  do {
    max=attracteur_max;
    for (i=0; i<NB_echantillon*NOMBRE_ELEMENT; i++){
      valeur=LitRAW(f,chiffre,index[i]);
      applique_le_pattern(chiffre);
    
      while(1) {
	elue=calcul_activation();

	if (vigilance(elue))
	  break;
	else
	  inhibe(elue);
      };
      printf("> %d %f %d\n",i,erreur,elue);
      modifier_les_poids(elue);
    }
  }while(max<attracteur_max);

  /* affectue  chaque attracteur un chiffre */
  for (i=0; i<NB_echantillon*NOMBRE_ELEMENT; i++){
    valeur=LitRAW(f,chiffre,index[i]);
    applique_le_pattern(chiffre);
    correspondance[calcul_activation()]=valeur;
  }

  /* Affiche les attracteurs */
  for (i=0; i<attracteur_max; i++){
    printf("%d %d\n",i,correspondance[i]);
    affiche_attracteur(i);
  }

  t1=clock();
  matrice_confusion(f);


  fermer_base(f);
  fclose(a);
  fclose(c);
  exit (0);
} 


void affiche_apprentissage_echantillon(int i){
  if ((Verbose>10) && ((clock())-t1 > CLOCKS_PER_SEC)){
    printf("%cChiffre: %d",13,i); fflush(stdout); t1=clock();}
}

