#include <stdio.h>
#include <stdlib.h>
#include "s_malloc.h"
#include "art.h"





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Charge un caractre du disque
  ATTENTION: Il y a allocation dynamique

  CELL * charger_char Le nouveau char

  char *n le nom du fichier o il y a le char
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
CELL * charger_char(char *n){
  FILE *f;
  int i,j;
  char c;
  CELL * tab;

  f=fopen (n,"r");
  tab = (CELL *)CALLOC(TAILLE_MAX*TAILLE_MAX,sizeof(CELL));

  for (j=0; j<TAILLE_MAX; j++){
    for (i=0; i<TAILLE_MAX; i++){
      fscanf(f,"%c",&c);
      acces(tab,i,j) = (c=='+'?0:1);
    }
    fscanf(f,"%c",&c);
  }

  fclose (f);
  return tab;
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  affiche un caractre

  CELL *c
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void affiche_char(CELL *c){
  int i,j;

  for (j=0; j<TAILLE_MAX; j++){
    for (i=0; i<TAILLE_MAX; i++)
      printf("%c",acces(c,i,j)?'#':' ');
    printf("\n");
  }
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Effectue la copie du chiffre c avec $\frac{bruit}{1000}$ de bruit

  CELL * copie_bruite le pointeur sur la copie

  CELL*c le chiffre d'origine

  CELL *tab la destination

  int bruit le bruit $\in [0,1000]$ 
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
CELL * copie_bruite(CELL*c,CELL *tab,int bruit){
  CELL x;
  int i,j;

  for (j=0; j<TAILLE_MAX; j++){
    for (i=0; i<TAILLE_MAX; i++){
      x=acces(c,i,j);
      if (1000.0*rand()/(RAND_MAX+1.0) < bruit)
	acces(tab,i,j)=(x==1?0:1);
      else
	acces(tab,i,j)=x;
    }}

  return (tab);
}
